<?php

namespace App\Http\Controllers\Admin;

use Exception;
use App\SliderPhoto;
use App\Slider;
use \Illuminate\View\View;
use Illuminate\Http\Request;
use App\SliderPhotoDescriptions;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\SliderDescription;
use App\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;
use App\Http\Requests\SliderRequest;
use Mcamara\LaravelLocalization\Facades\LaravelLocalization;

class SliderController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/sliders';
    /** View folder */
    private $viewDirectory= 'admin.sliders.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('sliders.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Slider::latest()
            ->join('slider_descriptions AS gd', 'sliders.id', 'gd.slider_id')
            ->where('gd.language_id', currentLanguage()->id)
            ->select(['gd.title', 'sliders.*']);

        if ($request->date_from) {
            $query->whereDate('sliders.created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('sliders.created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('gd.name', 'LIKE', '%'.$request->name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $sliders= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('sliders'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('sliders.store');
        $head = metaFields('sliders', 'add_new', getCurrentLocale()) ?? __('sliders.new');

        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param SliderRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(SliderRequest $request) :RedirectResponse
    {;
        $slider = Slider::create($request->all());
        // Insert Description
        $this->saveData( $request, $slider->id );

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Slider $slider
     * @return View
     */
    public function edit(Slider $slider) :View
    {
        $action= route('sliders.update', $slider->id);
        $head = metaFields('sliders', 'edit', getCurrentLocale()) ?? __('sliders.edit');

        $query = SliderDescription::where('slider_id', $slider->id)
            ->join('languages', 'languages.id', 'slider_descriptions.language_id')
            ->select(['slider_descriptions.*', 'languages.local']);

        $sliderDescription= $query->get();

        foreach ($sliderDescription as $row) {
            $slider[$row->local]= $row;
        }



        return view( $this->viewDirectory.'form', compact('slider', 'action', 'head') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param SliderRequest $request
     * @param Slider $slider
     * @return RedirectResponse|Redirector
     */
    public function update(SliderRequest $request, Slider $slider) :RedirectResponse
    {
        // Update the "updated_at" column only
        $slider->update($request->all());

        // Delete old description
        SliderDescription::where('slider_id', $slider->id)->delete();


        // Insert new description
        $this->saveData( $request, $slider->id );

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Handle Save form data
     *
     * @param SliderRequest $request
     * @param int $slider_id
     * @return void
     */

    private function saveData(SliderRequest $request, int $slider_id ):void
    {
        $requestData= $request->all();

        foreach (languages() as $language) {
            $sliderDescription=[
                'title'=> $requestData['title_'.$language->local],
                'description'=> $requestData['description_'.$language->local],
                'slider_id'=> $slider_id,
                'language_id'=> $language->id,
            ];

            SliderDescription::create($sliderDescription);
        }

    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $slider = Slider::withTrashed()->find($id);
        if ($slider) {
            if ($slider->deleted_at) {
                $slider->forceDelete();
            } else {
                $slider->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Slider::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Slider::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $slider = Slider::withTrashed()->find($id);

        if ($slider){
            $slider->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $slider = Slider::whereIn('id', $request->ids)->onlyTrashed();
        if ($slider){
            $slider->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
